diff --git a/src/backend/utils/misc/postgresql.conf.sample b/src/backend/utils/misc/postgresql.conf.sample
index bab7de3eee8..3c0958fc464 100644
--- a/src/backend/utils/misc/postgresql.conf.sample
+++ b/src/backend/utils/misc/postgresql.conf.sample
@@ -704,9 +704,11 @@
 #track_cost_delay_timing = off
 #track_io_timing = off
 #track_wal_io_timing = off
-#wait_event_capture = off               # off, stats
+#wait_event_capture = off               # off, stats, trace
                                         # (requires --enable-wait-event-timing)
 #wait_event_timing_max_tranches = 192   # (change requires restart)
+#wait_event_trace_ring_size = 4MB      # power of two, 8kB .. 32MB
+                                        # (change requires restart)
 #track_functions = none                 # none, pl, all
 #stats_fetch_consistency = cache        # cache, none, snapshot
 
diff --git a/src/include/storage/lwlocklist.h b/src/include/storage/lwlocklist.h
index f0a27019a11..ab842923db4 100644
--- a/src/include/storage/lwlocklist.h
+++ b/src/include/storage/lwlocklist.h
@@ -141,3 +141,4 @@ PG_LWLOCKTRANCHE(PARALLEL_VACUUM_DSA, ParallelVacuumDSA)
 PG_LWLOCKTRANCHE(AIO_URING_COMPLETION, AioUringCompletion)
 PG_LWLOCKTRANCHE(SHMEM_INDEX, ShmemIndex)
 PG_LWLOCKTRANCHE(WAIT_EVENT_TIMING_DSA, WaitEventTimingDSA)
+PG_LWLOCKTRANCHE(WAIT_EVENT_TRACE_DSA, WaitEventTraceDSA)
diff --git a/src/include/storage/subsystemlist.h b/src/include/storage/subsystemlist.h
index 331d60cf703..90b14235464 100644
--- a/src/include/storage/subsystemlist.h
+++ b/src/include/storage/subsystemlist.h
@@ -80,6 +80,7 @@ PG_SHMEM_SUBSYSTEM(AsyncShmemCallbacks)
 PG_SHMEM_SUBSYSTEM(StatsShmemCallbacks)
 PG_SHMEM_SUBSYSTEM(WaitEventCustomShmemCallbacks)
 PG_SHMEM_SUBSYSTEM(WaitEventTimingShmemCallbacks)
+PG_SHMEM_SUBSYSTEM(WaitEventTraceControlShmemCallbacks)
 #ifdef USE_INJECTION_POINTS
 PG_SHMEM_SUBSYSTEM(InjectionPointShmemCallbacks)
 #endif
diff --git a/src/include/utils/guc_hooks.h b/src/include/utils/guc_hooks.h
index 7896e9c7239..afd9017e45c 100644
--- a/src/include/utils/guc_hooks.h
+++ b/src/include/utils/guc_hooks.h
@@ -174,6 +174,7 @@ extern void assign_transaction_timeout(int newval, void *extra);
 extern const char *show_unix_socket_permissions(void);
 extern bool check_wait_event_capture(int *newval, void **extra, GucSource source);
 extern void assign_wait_event_capture(int newval, void *extra);
+extern bool check_wait_event_trace_ring_size(int *newval, void **extra, GucSource source);
 extern bool check_wal_buffers(int *newval, void **extra, GucSource source);
 extern bool check_wal_consistency_checking(char **newval, void **extra,
 										   GucSource source);
diff --git a/src/include/utils/wait_event_timing.h b/src/include/utils/wait_event_timing.h
index f1408dab279..03f74a84fe1 100644
--- a/src/include/utils/wait_event_timing.h
+++ b/src/include/utils/wait_event_timing.h
@@ -30,6 +30,8 @@
 
 #include "port/atomics.h"
 #include "portability/instr_time.h"
+#include "storage/lwlock.h"
+#include "utils/dsa.h"
 #include "utils/wait_event_types.h"
 
 /*
@@ -40,23 +42,26 @@
  *   OFF   - No instrumentation, no hot-path cost.
  *   STATS - Aggregated per-event statistics (counts, durations, histogram)
  *           exposed via pg_stat_wait_event_timing.
- *
- * A further TRACE level is added later in the series.
+ *   TRACE - Everything in STATS plus a per-session ring buffer of individual
+ *           wait events and query-attribution markers, exposed via
+ *           pg_backend_wait_event_trace.
  */
 typedef enum WaitEventCaptureLevel
 {
 	WAIT_EVENT_CAPTURE_OFF = 0,
 	WAIT_EVENT_CAPTURE_STATS,
+	WAIT_EVENT_CAPTURE_TRACE,
 } WaitEventCaptureLevel;
 
 /*
- * Pin the enum ordering at compile time so future code that compares with
- * >= against WAIT_EVENT_CAPTURE_STATS keeps working, and so reordering is
- * caught at build time rather than via mysterious runtime mode switches.
+ * Pin the enum ordering at compile time so code that compares with >= keeps
+ * working, and so reordering is caught at build time rather than via
+ * mysterious runtime mode switches.
  */
 StaticAssertDecl(WAIT_EVENT_CAPTURE_OFF == 0 &&
-				 WAIT_EVENT_CAPTURE_STATS == 1,
-				 "WaitEventCaptureLevel values must be 0=OFF < 1=STATS");
+				 WAIT_EVENT_CAPTURE_STATS == 1 &&
+				 WAIT_EVENT_CAPTURE_TRACE == 2,
+				 "WaitEventCaptureLevel values must be 0=OFF < 1=STATS < 2=TRACE");
 
 /*
  * Number of log2 histogram buckets.  Bin edges are powers of two on the
@@ -186,11 +191,170 @@ extern PGDLLIMPORT int wait_event_capture;
 extern PGDLLIMPORT WaitEventTimingState *my_wait_event_timing;
 
 /*
- * Called from InitProcess()/InitAuxiliaryProcess() to point
- * my_wait_event_timing at this backend's slot, and from ProcKill() to
- * clear it.
+ * Called from InitProcess()/InitAuxiliaryProcess() to set up this backend's
+ * timing/trace bookkeeping, and from ProcKill() to clear it.
  */
 extern void pgstat_set_wait_event_timing_storage(int procNumber);
 extern void pgstat_reset_wait_event_timing_storage(void);
 
+
+/* ----------------------------------------------------------------------
+ * Trace level (wait_event_capture = trace)
+ *
+ * In addition to the STATS aggregates, every completed wait (and a set of
+ * query-attribution markers) is pushed into a per-session ring buffer --
+ * one record per completed wait.  The ring is allocated lazily in DSA on
+ * first use,
+ * so only sessions that enable trace pay the per-ring memory cost.  External
+ * tools read a session's ring via pg_get_backend_wait_event_trace() (own
+ * session) or pg_get_wait_event_trace(procnumber) (cross-backend).
+ *
+ * Query attribution is by scanning the ring at read time: QUERY/EXEC
+ * START/END markers delimit which wait events belong to which query_id.
+ *
+ * The ring size is set cluster-wide at server start by the
+ * wait_event_trace_ring_size GUC (PGC_POSTMASTER, default 4 MB).  It
+ * MUST be a power of two: the writer indexes the ring as (pos & ring_mask).
+ * ----------------------------------------------------------------------
+ */
+
+/* Trace record types */
+#define TRACE_WAIT_EVENT	0
+#define TRACE_QUERY_START	1
+#define TRACE_QUERY_END		2
+#define TRACE_EXEC_START	3
+#define TRACE_EXEC_END		4
+
+typedef struct WaitEventTraceRecord
+{
+	/*
+	 * Seqlock for torn-read detection.  Writers set seq odd before filling
+	 * fields, then even after; readers check seq before and after and skip
+	 * the record if either is odd or they differ.  uint32 wrap is irrelevant
+	 * over the ~10-20 ns reader access window.
+	 */
+	uint32		seq;
+	uint8		record_type;	/* TRACE_WAIT_EVENT / QUERY_* / EXEC_* */
+	uint8		pad[3];
+	int64		timestamp_ns;	/* monotonic clock */
+	union
+	{
+		struct					/* record_type = TRACE_WAIT_EVENT */
+		{
+			uint32		event;	/* wait_event_info */
+			uint32		pad2;
+			int64		duration_ns;
+		}			wait;
+		struct					/* QUERY_START/END or EXEC_START/END */
+		{
+			int64		query_id;
+			int64		pad2;
+		}			query;
+	}			data;
+} WaitEventTraceRecord;			/* 32 bytes */
+
+/*
+ * The seqlock wrap-safety argument and the mask-index math both rely on a
+ * fixed 32-byte record stride; make a stray field addition a build failure.
+ */
+StaticAssertDecl(sizeof(WaitEventTraceRecord) == 32,
+				 "WaitEventTraceRecord must be exactly 32 bytes");
+
+/*
+ * Per-backend trace ring header followed by the records array.  records[]
+ * is variably sized at allocation time (wait_event_trace_ring_size
+ * decides the row count).  write_pos and ring_mask share a cache line so
+ * the hot-path index calculation touches one line.
+ */
+typedef struct WaitEventTraceState
+{
+	pg_atomic_uint64 write_pos; /* monotonically increasing, wraps via mask */
+	uint32		ring_mask;		/* ring_size - 1; ring_size is a power of two */
+	uint32		ring_size_pad;	/* keep the records[] slab 16-byte aligned */
+	WaitEventTraceRecord records[FLEXIBLE_ARRAY_MEMBER];
+} WaitEventTraceState;
+
+/*
+ * Per-procNumber trace-ring slot lifecycle.  Decoupled from backend
+ * lifecycle on purpose: when a backend exits we transition its slot to
+ * ORPHANED and leave the ring in DSA so cross-backend consumers can still
+ * read the dying backend's final waits.  An orphan is reclaimed when a new
+ * backend takes the same procNumber, or by
+ * pg_stat_clear_orphaned_wait_event_rings().
+ *
+ *   FREE      no ring allocated (ring_ptr invalid).
+ *   OWNED     a live backend at this procNumber is writing to the ring.
+ *   ORPHANED  the owner exited; the ring is post-mortem and immutable.
+ */
+typedef enum WaitEventTraceSlotState
+{
+	WAIT_EVENT_TRACE_SLOT_FREE = 0,
+	WAIT_EVENT_TRACE_SLOT_OWNED,
+	WAIT_EVENT_TRACE_SLOT_ORPHANED,
+} WaitEventTraceSlotState;
+
+/*
+ * Per-procNumber slot.  generation is bumped on every owner transition;
+ * cross-backend readers snapshot it before+after their read and retry if it
+ * changed (the BackendStatusArray st_changecount idiom).  state is atomic
+ * only for cheap unlocked "worth visiting" probes; authoritative reads of
+ * (state, ring_ptr) are done under WaitEventTraceCtl->lock in LW_SHARED,
+ * while every transition holds it LW_EXCLUSIVE.
+ */
+typedef struct WaitEventTraceSlot
+{
+	pg_atomic_uint64 generation;	/* bumped on every owner transition */
+	pg_atomic_uint32 state;		/* WaitEventTraceSlotState */
+	uint32		pad;			/* keep ring_ptr 8-aligned */
+	dsa_pointer ring_ptr;		/* InvalidDsaPointer when FREE; else the
+								 * WaitEventTraceState chunk */
+} WaitEventTraceSlot;
+
+/*
+ * Control struct in fixed shared memory.  trace_slots[] is indexed by
+ * procNumber.
+ *
+ * External cross-backend reader protocol (pg_get_wait_event_trace is the
+ * reference implementation):
+ *   1. read trace_slots[procNumber].state unlocked as a "worth visiting"
+ *      probe; FREE -> nothing to read.
+ *   2. acquire lock LW_SHARED (all transitions take LW_EXCLUSIVE, so the
+ *      slot's state/ring_ptr/ring memory are stable for the iteration).
+ *   3. re-check state under the lock; resolve ring_ptr via dsa_get_address;
+ *      read write_pos.
+ *   4. iterate [read_start, write_pos): for each record do the per-record
+ *      POSITION-ENCODED IDENTITY seqlock check against shared memory --
+ *      expected_seq = (uint32)(i*2 + 2); read seq, barrier, copy record,
+ *      barrier, re-read seq; accept only if both equal expected_seq.  This
+ *      rejects stale previous-cycle reads (parity alone would not).
+ *   5. release the lock; emit the buffered records afterwards.
+ *   6. optional: snapshot generation before/after if releasing the lock
+ *      between batches.
+ */
+typedef struct WaitEventTraceControl
+{
+	dsa_handle	trace_dsa_handle;	/* DSA_HANDLE_INVALID until first use */
+	LWLock		lock;			/* protects DSA creation and slot transitions */
+	WaitEventTraceSlot trace_slots[FLEXIBLE_ARRAY_MEMBER];	/* per procNumber */
+} WaitEventTraceControl;
+
+/* Trace GUC and the records-per-ring value derived from it at startup. */
+extern PGDLLIMPORT int wait_event_trace_ring_size;
+extern PGDLLIMPORT uint32 WaitEventTraceRingSize;
+
+/* This backend's procNumber for the trace ring, or -1 if not set. */
+extern PGDLLIMPORT int my_trace_proc_number;
+
+/*
+ * Lazy DSA-based trace ring allocation -- called on first trace write and
+ * at backend startup when capture = trace was set via configuration.
+ */
+extern void wait_event_trace_attach(int procNumber);
+
+/* Query-attribution markers (defined in wait_event_timing.c). */
+extern void wait_event_trace_query_start(int64 query_id);
+extern void wait_event_trace_query_end(int64 query_id);
+extern void wait_event_trace_exec_start(int64 query_id);
+extern void wait_event_trace_exec_end(int64 query_id);
+
 #endif							/* WAIT_EVENT_TIMING_H */
diff --git a/src/test/modules/test_misc/meson.build b/src/test/modules/test_misc/meson.build
index ee290698b31..aba6fbdf86e 100644
--- a/src/test/modules/test_misc/meson.build
+++ b/src/test/modules/test_misc/meson.build
@@ -23,6 +23,7 @@ tests += {
       't/012_ddlutils.pl',
       't/013_temp_obj_multisession.pl',
       't/014_log_statement_max_length.pl',
+      't/015_wait_event_trace_seqlock.pl',
     ],
     # The injection points are cluster-wide, so disable installcheck
     'runningcheck': false,
diff --git a/src/test/modules/test_misc/t/015_wait_event_trace_seqlock.pl b/src/test/modules/test_misc/t/015_wait_event_trace_seqlock.pl
new file mode 100644
index 00000000000..0f0e49970c8
--- /dev/null
+++ b/src/test/modules/test_misc/t/015_wait_event_trace_seqlock.pl
@@ -0,0 +1,122 @@
+# Copyright (c) 2026, PostgreSQL Global Development Group
+
+# Test the position-encoded identity seqlock that protects cross-backend
+# reads of the wait-event trace ring (wait_event_capture = trace).
+#
+# The hazard: the trace writer advances write_pos and only then stamps the
+# record's seq.  A cross-backend reader that observes the new write_pos
+# before the seq store has propagated sees, at the in-flight ring slot, the
+# PREVIOUS cycle's record -- complete, with an even seq.  A parity-only
+# seqlock would accept it and emit a stale record attributed to the wrong
+# ring index; the identity check (seq must equal the writer's completion
+# value for that exact position) must reject it.
+#
+# That window is unobservable on TSO hardware without instrumentation, so
+# the writer carries INJECTION_POINT("wait-event-trace-after-write-pos")
+# between the write_pos advance and the seq stamp.  This test:
+#
+#   1. fills and wraps a minimum-size ring (8kB = 256 records), so every
+#      slot holds a complete record from the previous cycle;
+#   2. wedges the writer at the injection point, mid-record;
+#   3. reads the ring cross-backend: the reader must return exactly
+#      ring_size - 1 records, skipping the in-flight slot whose stale
+#      prior-cycle record a parity-only check would have emitted;
+#   4. releases the writer and verifies the ring reads full again.
+
+use strict;
+use warnings FATAL => 'all';
+
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+plan skip_all => 'Injection points not supported by this build'
+  unless $ENV{enable_injection_points} eq 'yes';
+
+my $ring_records = 256;			# 8kB ring / 32-byte records
+
+my $node = PostgreSQL::Test::Cluster->new('seqlock');
+$node->init;
+$node->append_conf(
+	'postgresql.conf', q[
+wait_event_trace_ring_size = '8kB'
+]);
+$node->start;
+
+# Skip if the server was not built with --enable-wait-event-timing.
+my ($ret, $stdout, $stderr) =
+  $node->psql('postgres', 'SET wait_event_capture = trace;');
+if ($ret != 0)
+{
+	$node->stop;
+	plan skip_all => 'server not built with --enable-wait-event-timing';
+}
+
+$node->safe_psql('postgres', 'CREATE EXTENSION injection_points;');
+
+# Writer session: enable trace and wrap the ring.  400 pg_sleep calls emit
+# at least 400 wait events into a 256-record ring, so every slot holds a
+# complete record from the current window.
+my $writer = $node->background_psql('postgres');
+$writer->query_safe('SET wait_event_capture = trace;');
+$writer->query_safe(
+	'SELECT count(pg_sleep(0.001)) FROM generate_series(1, 400);');
+
+my $writer_proc = $writer->query_safe(
+	'SELECT procnumber FROM pg_stat_get_wait_event_timing(pg_backend_pid())'
+	  . ' LIMIT 1;');
+chomp $writer_proc;
+like($writer_proc, qr/^\d+$/, 'writer reported its procnumber');
+
+# With the ring wrapped and the writer idle, a cross-backend read returns
+# exactly ring_size records: every slot is complete and identity-valid.
+my $count_full = $node->safe_psql('postgres',
+	"SELECT count(*) FROM pg_get_wait_event_trace($writer_proc);");
+is($count_full, $ring_records, 'wrapped ring reads full before the wedge');
+
+# Wedge the writer mid-record: arm the injection point, then send a
+# statement.  The arrival of the statement completes the writer's
+# ClientRead wait; its trace write advances write_pos and then blocks at
+# the injection point, before stamping the record's seq.
+$node->safe_psql('postgres',
+	"SELECT injection_points_attach('wait-event-trace-after-write-pos', 'wait');"
+);
+$writer->query_until(
+	qr/wedge_sent/, q[
+\echo wedge_sent
+SELECT 1;
+]);
+$node->wait_for_event('client backend', 'wait-event-trace-after-write-pos');
+
+# The decisive read: the in-flight slot still holds the previous cycle's
+# complete record.  A parity-only seqlock would emit it (ring_size rows,
+# one misattributed); the identity check must skip exactly that slot.
+my $count_wedged = $node->safe_psql('postgres',
+	"SELECT count(*) FROM pg_get_wait_event_trace($writer_proc);");
+is($count_wedged, $ring_records - 1,
+	'reader skips the in-flight slot instead of emitting the stale prior-cycle record'
+);
+
+# The read is stable and repeatable while the writer is wedged.
+my $count_wedged2 = $node->safe_psql('postgres',
+	"SELECT count(*) FROM pg_get_wait_event_trace($writer_proc);");
+is($count_wedged2, $count_wedged, 'wedged-ring read is stable');
+
+# Release the writer: detach first so the nested wakeup wait does not
+# re-arm, then wake it.
+$node->safe_psql('postgres',
+	"SELECT injection_points_detach('wait-event-trace-after-write-pos');");
+$node->safe_psql('postgres',
+	"SELECT injection_points_wakeup('wait-event-trace-after-write-pos');");
+
+# The writer completes the wedged record (and its pending statement); the
+# ring must read full again.
+$writer->query_safe("SELECT 'resync';");
+my $count_after = $node->safe_psql('postgres',
+	"SELECT count(*) FROM pg_get_wait_event_trace($writer_proc);");
+is($count_after, $ring_records, 'ring reads full again after release');
+
+$writer->quit;
+$node->stop;
+
+done_testing();
diff --git a/src/test/regress/sql/wait_event_timing.sql b/src/test/regress/sql/wait_event_timing.sql
index a30fcd155fd..49206afef66 100644
--- a/src/test/regress/sql/wait_event_timing.sql
+++ b/src/test/regress/sql/wait_event_timing.sql
@@ -1,9 +1,10 @@
 --
 -- WAIT_EVENT_TIMING
 --
--- Exercises the wait_event_capture = stats instrumentation: the GUC, the
--- pg_stat_get_wait_event_timing() SRF, the pg_stat_wait_event_timing view,
--- and the pg_wait_event_timing_histogram_buckets taxonomy view.
+-- Exercises the wait_event_capture instrumentation: the GUC, the stats
+-- surface (pg_stat_get_wait_event_timing(), the pg_stat_wait_event_timing
+-- and histogram-buckets views, overflow counters, resets), and the trace
+-- surface (the per-session ring and its readers).
 --
 -- Two expected outputs are maintained:
 --   wait_event_timing.out    -- --enable-wait-event-timing builds
@@ -77,3 +78,27 @@ SELECT pg_stat_reset_wait_event_timing();
 SELECT pg_stat_reset_wait_event_timing(2147483647);
 
 RESET wait_event_capture;
+
+--
+-- Trace level: per-session ring of individual waits + query markers.
+-- (In a stub build SET trace errors and the trace readers stay empty;
+-- that is the documented difference between the two expected files.)
+--
+SET wait_event_capture = trace;
+SELECT pg_sleep(0.1);
+
+-- PgSleep is recorded in this backend's ring with a positive duration.
+SELECT count(*) >= 1 AS pgsleep_in_ring,
+       coalesce(bool_and(duration_us > 0), false) AS durations_positive
+FROM pg_get_backend_wait_event_trace()
+WHERE wait_event = 'PgSleep';
+
+-- The same records are visible through the view.
+SELECT count(*) >= 1 AS view_has_pgsleep
+FROM pg_backend_wait_event_trace
+WHERE wait_event = 'PgSleep';
+
+-- Clearing orphaned rings is a no-op here (no orphans) but must succeed.
+SELECT pg_stat_clear_orphaned_wait_event_rings() >= 0 AS clear_orphans_ok;
+
+RESET wait_event_capture;
diff --git a/src/tools/pgindent/typedefs.list b/src/tools/pgindent/typedefs.list
index 12d244fd910..3bcea372901 100644
--- a/src/tools/pgindent/typedefs.list
+++ b/src/tools/pgindent/typedefs.list
@@ -3433,6 +3433,11 @@ WaitEventTimeout
 WaitEventTimingControl
 WaitEventTimingEntry
 WaitEventTimingState
+WaitEventTraceControl
+WaitEventTraceRecord
+WaitEventTraceSlot
+WaitEventTraceSlotState
+WaitEventTraceState
 WaitLSNProcInfo
 WaitLSNResult
 WaitLSNState
@@ -3463,6 +3468,7 @@ WalUsage
 WalWriteMethod
 WalWriteMethodOps
 Walfile
+WetValidRecord
 WindowAgg
 WindowAggPath
 WindowAggState
-- 
2.43.0

